#
# Enhydra Java Application Server Project
# 
# The contents of this file are subject to the Enhydra Public License
# Version 1.1 (the "License"); you may not use this file except in
# compliance with the License. You may obtain a copy of the License on
# the Enhydra web site ( http://www.enhydra.org/ ).
# 
# Software distributed under the License is distributed on an "AS IS"
# basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See 
# the License for the specific terms governing rights and limitations
# under the License.
# 
# The Initial Developer of the Enhydra Application Server is Lutris
# Technologies, Inc. The Enhydra Application Server and portions created
# by Lutris Technologies, Inc. are Copyright Lutris Technologies, Inc.
# All Rights Reserved.
# 
# Contributor(s):
# 
# $Id$
#
include $(ENHYDRA_DIR)/lib/stdrules.mk

#output directory for deployed beans and webapp
ifeq ($(DEPLOYED_OUTPUT),)
    DEPLOYED_OUTPUT=$(OUTPUT)/deployed
endif


#rule for list of ejb to deploy
ifneq ($(DEPLOY_EJB),)
    misc_build_targets:: $(DEPLOY_EJB:%=$(DEPLOYED_OUTPUT)/%.jar)
endif

#rule for list of web app to deploy
ifneq ($(DEPLOY_WEB),)
    misc_build_targets:: $(DEPLOY_WEB:%=$(DEPLOYED_OUTPUT)/%.war)
endif

#classpath to components
ENHYDRA_CLASSPATH:=$(OUTPUT)/lib/ejb-jar.jar${PS}${ENHYDRA_CLASSPATH}


#deployed ejb-jar are extracted to deployed output
#this works for only one ejb-jar
$(DEPLOYED_OUTPUT)/%.jar:
	mkdir -p $(DEPLOYED_OUTPUT)
	(cd $(DEPLOYED_OUTPUT) && $(JAR) -x) <$(LIB_OUTPUT)/$*.jar
	$(JAVA) -cp $(ENHYDRA_CLASSPATH) org.objectweb.jonas.tools.GenIC -d $(DEPLOYED_OUTPUT) -javac $(JAVAC) -javacopts "-classpath ${ENHYDRA_CLASSPATH}${PS}$(DEPLOYED_OUTPUT)${PS}$(LIB_OUTPUT)/$*.jar" -rmicopts "-classpath ${ENHYDRA_CLASSPATH}${PS}$(DEPLOYED_OUTPUT)${PS}$(LIB_OUTPUT)/$*.jar" $(LIB_OUTPUT)/$*.jar
	cp -f $(LIB_OUTPUT)/$*.jar $@
	
	
#deployed web-app are extracted to deployed output
#this works for only one ejb-jar
$(DEPLOYED_OUTPUT)/%.war:
	mkdir -p $(DEPLOYED_OUTPUT)
	(cd $(DEPLOYED_OUTPUT) && $(JAR) -x) <$(LIB_OUTPUT)/$*.jar
	cp -f $(LIB_OUTPUT)/$*.jar $@

