/*
 * Enhydra Java Application Server Project
 * 
 * The contents of this file are subject to the Enhydra Public License
 * Version 1.1 (the "License"); you may not use this file except in
 * compliance with the License. You may obtain a copy of the License on
 * the Enhydra web site ( http://www.enhydra.org/ ).
 * 
 * Software distributed under the License is distributed on an "AS IS"
 * basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See 
 * the License for the specific terms governing rights and limitations
 * under the License.
 * 
 * The Initial Developer of the Enhydra Application Server is Lutris
 * Technologies, Inc. The Enhydra Application Server and portions created
 * by Lutris Technologies, Inc. are Copyright Lutris Technologies, Inc.
 * All Rights Reserved.
 * 
 * Contributor(s):
 * 
 * $Id$
 */

package org.enhydra.kelp.common.bridge;

// Kelp imports
import org.enhydra.kelp.common.node.OtterXMLCNode;

// XMLC imports
import org.enhydra.xml.xmlc.XMLCException;

// Standard imports
import java.io.File;
import java.io.IOException;
import java.io.PrintWriter;


public interface MetaDataHandler {

  public void parse(String[] files, String[] args, PrintWriter writer,
     OtterXMLCNode node)
    throws XMLCException, IOException;

  public Object getMetaData();

  public Object[] getURLMappings();
  public Object[] getDeleteElements();

  public String getClassName();
  public void setClassName(String n);

  public String getPackageName();

  public File getJavaClassSource();
  public void setJavaClassSource(File f, OtterXMLCNode node);

  public File getJavaInterfaceSource();
  public void setJavaInterfaceSource(File f, OtterXMLCNode node);

  public String getInputDocument();
  public void setInputDocument(String s);

  public String getDocumentOutput();
  public void setDocumentOutput(String s);

  public boolean getCompileSource();
  public void setCompileSource(boolean b);

  public boolean getKeepGeneratedSource();
  public void setKeepGeneratedSource(boolean keep);

  public boolean getPrintParseInfo();
  public void setPrintParseInfo(boolean b);

  public boolean getPrintDOM();
  public void setPrintDOM(boolean b);

  public boolean getVerbose();
  public void setVerbose(boolean b);

  public boolean getPrintAccessorInfo();
  public void setPrintAccessorInfo(boolean b);

  public boolean getRecompilation();
  public void setRecompilation(boolean b);

  public boolean getPrintVersion();
  public void setPrintVersion(boolean b);

  public void save(File f) throws IOException;

}
