/*
 * Enhydra Java Application Server Project
 * 
 * The contents of this file are subject to the Enhydra Public License
 * Version 1.1 (the "License"); you may not use this file except in
 * compliance with the License. You may obtain a copy of the License on
 * the Enhydra web site ( http://www.enhydra.org/ ).
 * 
 * Software distributed under the License is distributed on an "AS IS"
 * basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See 
 * the License for the specific terms governing rights and limitations
 * under the License.
 * 
 * The Initial Developer of the Enhydra Application Server is Lutris
 * Technologies, Inc. The Enhydra Application Server and portions created
 * by Lutris Technologies, Inc. are Copyright Lutris Technologies, Inc.
 * All Rights Reserved.
 * 
 * Contributor(s):
 * 
 * $Id$
 */
package org.enhydra.kelp.common.wizard.conf;

import org.enhydra.kelp.common.swing.DirectoryFilter;
import org.enhydra.kelp.common.swing.SwingUtil;


import java.awt.Dimension;
import java.awt.Dialog;
import java.awt.Frame;
import java.awt.GridBagLayout;
import java.awt.GridBagConstraints;
import java.awt.Insets;
import java.awt.Point;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.io.File;
import java.beans.Beans;

import javax.swing.JButton;
import javax.swing.JDialog;
import javax.swing.JPanel;
import javax.swing.JTextField;
import javax.swing.JLabel;

/**
 * Class declaration
 *
 *
 * @author
 * @version %I%, %G%
 */
public class ReplaceEditorDialog extends JDialog {
    public static final int     ACTION_OK = 0;
    public static final int     ACTION_CANCEL = 1;
    private static File		startFolder = null;
    private int			option = ACTION_CANCEL;
    private LocalButtonListener buttonListener = null;
    private JPanel		panelMain = new JPanel();
    private GridBagLayout       layoutMain;
    private JPanel		panelEntry;
    private GridBagLayout       layoutEntry;
    private JPanel		panelButtons;
    private GridBagLayout       layoutButton;
    private JLabel		labelFind;
    private JTextField		textFind;
    private JButton		buttonBrowse;
    private JLabel		labelReplaceWith;
    private JTextField		textReplaceWith;
    private JButton		buttonCancel;
    private JButton		buttonOK;

    /**
     * Constructor declaration
     *
     *
     * @param owner
     * @param title
     * @param modal
     *
     * @see
     */
    public ReplaceEditorDialog(Dialog owner, String title, boolean modal) {
      super(owner, title, modal);
      construct();
    }

    public ReplaceEditorDialog(Frame owner, String title, boolean modal) {
	super(owner, title, modal);
        construct();
    }

    private void construct() {
	try {
	    jbInit();
	    pmInit();
	    pack();
	} catch (Exception ex) {
	    ex.printStackTrace();
	}
    }

    /**
     * Constructor declaration
     *
     *
     * @see
     */
    public ReplaceEditorDialog() {
	this(new Frame(), "", false);
    }

    /**
     * Method declaration
     *
     *
     * @see
     */
    public void show() {
	setResizable(false);

	Point cPoint;

	invalidate();
	doLayout();
	pack();

	cPoint = SwingUtil.getCenteringPoint(getSize());

	setLocation(cPoint);
	super.show();
    }

    /**
     * Method declaration
     *
     *
     * @see
     */
    private void pmInit() {
	buttonListener = new LocalButtonListener();

	buttonBrowse.addActionListener(buttonListener);
	buttonOK.addActionListener(buttonListener);
	buttonCancel.addActionListener(buttonListener);
	textFind.setText(new String());
	textReplaceWith.setText(new String());
    }

    /**
     * Method declaration
     *
     *
     * @throws Exception
     *
     * @see
     */
    private void jbInit() throws Exception {
	layoutMain =
	    (GridBagLayout) Beans.instantiate(getClass().getClassLoader(),
					      GridBagLayout.class.getName());
	panelEntry = (JPanel) Beans.instantiate(getClass().getClassLoader(),
						JPanel.class.getName());
	layoutEntry =
	    (GridBagLayout) Beans.instantiate(getClass().getClassLoader(),
					      GridBagLayout.class.getName());
	panelButtons = (JPanel) Beans.instantiate(getClass().getClassLoader(),
						  JPanel.class.getName());
	layoutButton =
	    (GridBagLayout) Beans.instantiate(getClass().getClassLoader(),
					      GridBagLayout.class.getName());
	labelFind = (JLabel) Beans.instantiate(getClass().getClassLoader(),
						 JLabel.class.getName());
	textFind =
	    (JTextField) Beans.instantiate(getClass().getClassLoader(),
					   JTextField.class.getName());
	buttonBrowse =
	    (JButton) Beans.instantiate(getClass().getClassLoader(),
					JButton.class.getName());
	labelReplaceWith = (JLabel) Beans.instantiate(getClass().getClassLoader(),
						  JLabel.class.getName());
	textReplaceWith =
	    (JTextField) Beans.instantiate(getClass().getClassLoader(),
					   JTextField.class.getName());
	buttonCancel =
	    (JButton) Beans.instantiate(getClass().getClassLoader(),
					JButton.class.getName());
	buttonOK = (JButton) Beans.instantiate(getClass().getClassLoader(),
					       JButton.class.getName());

	panelMain.setLayout(layoutMain);
	panelEntry.setLayout(layoutEntry);
	panelButtons.setLayout(layoutButton);
	labelFind.setText("Text to Find:");
	textFind.setPreferredSize(new Dimension(250, 21));
	textFind.setText("jTextField1");
	labelReplaceWith.setText("Replace With:");
	textReplaceWith.setPreferredSize(new Dimension(250, 21));
	textReplaceWith.setText("jTextField2");
	buttonBrowse.setText("Browse...");

	buttonCancel.setText("Cancel");
	buttonOK.setText("OK");
	getContentPane().add(panelMain);
	panelMain.add(panelEntry,
		      new GridBagConstraints(0, 0, 1, 1, 0.2, 0.2,
					     GridBagConstraints.CENTER,
					     GridBagConstraints.BOTH,
					     new Insets(0, 0, 0, 0), 0, 0));
	panelEntry.add(labelFind,
		       new GridBagConstraints(0, 0, 1, 1, 0.2, 0.2,
					      GridBagConstraints.WEST,
					      GridBagConstraints.HORIZONTAL,
					      new Insets(5, 5, 5, 5), 0, 0));
	panelEntry.add(textFind,
		       new GridBagConstraints(0, 1, 1, 1, 0.4, 0.4,
					      GridBagConstraints.WEST,
					      GridBagConstraints.HORIZONTAL,
					      new Insets(5, 5, 5, 5), 200,
					      0));
	panelEntry.add(labelReplaceWith,
		       new GridBagConstraints(0, 2, 1, 1, 0.2, 0.2,
					      GridBagConstraints.WEST,
					      GridBagConstraints.HORIZONTAL,
					      new Insets(5, 5, 5, 5), 0, 0));
	panelEntry.add(textReplaceWith,
		       new GridBagConstraints(0, 3, 1, 1, 0.4, 0.4,
					      GridBagConstraints.WEST,
					      GridBagConstraints.HORIZONTAL,
					      new Insets(5, 5, 5, 5), 200,
					      0));
    panelEntry.add(buttonBrowse, new GridBagConstraints(1, 3, 1, 1, 0.2, 0.2
            ,GridBagConstraints.CENTER, GridBagConstraints.NONE, new Insets(5, 5, 5, 5), 0, 0));
	panelMain.add(panelButtons,
		      new GridBagConstraints(0, 1, 1, 1, 0.2, 0.2,
					     GridBagConstraints.CENTER,
					     GridBagConstraints.BOTH,
					     new Insets(5, 5, 5, 0), 0, 0));
	panelButtons.add(buttonOK,
			 new GridBagConstraints(0, 0, 1, 1, 0.0, 0.0,
						GridBagConstraints.CENTER,
						GridBagConstraints.NONE,
						new Insets(5, 5, 5, 5), 0,
						0));
	panelButtons.add(buttonCancel,
			 new GridBagConstraints(1, 0, 1, 1, 0.0, 0.0,
						GridBagConstraints.CENTER,
						GridBagConstraints.NONE,
						new Insets(5, 5, 5, 5), 0,
						0));
    }

    /**
     * Method declaration
     *
     *
     * @see
     */
    protected void closeDialog() {
	setVisible(false);
	removeAll();
	dispose();
    }

    /**
     * Method declaration
     *
     *
     * @return
     *
     * @see
     */
    protected int getOption() {
	return option;
    }

    /**
     * Method declaration
     *
     *
     * @return
     *
     * @see
     */
    protected String getFind() {
	return textFind.getText();
    }

    protected void setFind(String find) {
	textFind.setText(find);
    }


    /**
     * Method declaration
     *
     *
     * @return
     *
     * @see
     */
    protected String getReplaceWith() {
	return textReplaceWith.getText();
    }

    protected void setReplaceWith(String replace) {
         textReplaceWith.setText(replace);
    }

    /**
     * Method declaration
     *
     *
     * @param o
     *
     * @see
     */
    private void setOption(int o) {
	option = o;
    }

    /**
     * Method declaration
     *
     *
     * @see
     */
    private void browseAction() {
	File choice;

	if (startFolder == null ||!startFolder.exists()) {
	    startFolder = new File(textReplaceWith.getText());
	}

	choice =
	    SwingUtil.getDirectoryChoice(this, startFolder,
					 "Select folder to use as replacement text");

	buttonBrowse.requestFocus();

	if (choice != null) {
	    textReplaceWith.setText(choice.toString());

	    startFolder = choice;    // persist this choice for next call
	}
    }

    /**
     * Class declaration
     *
     *
     * @author
     * @version %I%, %G%
     */
    class LocalButtonListener implements ActionListener {

	/**
	 * Method declaration
	 *
	 *
	 * @param event
	 *
	 * @see
	 */
	public void actionPerformed(ActionEvent event) {
	    Object source = event.getSource();

	    if (source == buttonBrowse) {
		browseAction();
	    } else if (source == buttonOK) {
		setOption(ACTION_OK);
		closeDialog();
	    } else if (source == buttonCancel) {
		setOption(ACTION_CANCEL);
		closeDialog();
	    }
	}

    }

}
