/*
 * Enhydra Java Application Server Project
 * 
 * The contents of this file are subject to the Enhydra Public License
 * Version 1.1 (the "License"); you may not use this file except in
 * compliance with the License. You may obtain a copy of the License on
 * the Enhydra web site ( http://www.enhydra.org/ ).
 * 
 * Software distributed under the License is distributed on an "AS IS"
 * basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See 
 * the License for the specific terms governing rights and limitations
 * under the License.
 * 
 * The Initial Developer of the Enhydra Application Server is Lutris
 * Technologies, Inc. The Enhydra Application Server and portions created
 * by Lutris Technologies, Inc. are Copyright Lutris Technologies, Inc.
 * All Rights Reserved.
 * 
 * Contributor(s):
 * 
 * $Id$
 */
package org.enhydra.kelp.jbuilder.properties;

import org.enhydra.kelp.common.node.OtterTemplateNode;
import org.enhydra.kelp.common.wizard.conf.ConfNodePropertyPanel;
import org.enhydra.kelp.jbuilder.node.PrimeTemplateNode;
import org.enhydra.kelp.common.swing.SwingUtil;
import com.borland.primetime.properties.*;
import com.borland.primetime.help.HelpTopic;
import com.borland.primetime.node.FileNode;
import com.borland.primetime.node.TextFileNode;
import com.borland.primetime.help.ZipHelpTopic;

import java.util.*;
import javax.swing.*;
import java.awt.*;
import java.awt.event.*;

public class ConfNodePropertyPage extends PropertyPage {
  private ConfNodePropertyPanel nodePanel = new ConfNodePropertyPanel();
  private BorderLayout layoutMain  = new BorderLayout();
  private final String HELP_TOPIC = "file:../kelp1.2/doc/developer/jb-kelp.html#confnode";

  public ConfNodePropertyPage(Object topic) {
    OtterTemplateNode otterNode;
    if (topic instanceof FileNode) {
       otterNode = new PrimeTemplateNode((TextFileNode)topic);
      try {
        nodePanel.setNode(otterNode);
        jbInit();
      }
      catch(Exception e) {
        e.printStackTrace();
      }
    }
  }

  public void readProperties() {
    nodePanel.readProperties();
  }

  public HelpTopic getHelpTopic() {
    ZipHelpTopic t = new ZipHelpTopic( null, HELP_TOPIC );
    return t;
  }

  public void writeProperties() {
    nodePanel.writeProperties();
  }

  public ConfNodePropertyPage() {
    try {
      jbInit();
    } catch(Exception e) {
      e.printStackTrace();
    }
  }

  private void jbInit() throws Exception {
    this.setLayout(layoutMain);
    this.add(nodePanel, BorderLayout.CENTER);
  }

}
