/*
 * Enhydra Java Application Server Project
 * 
 * The contents of this file are subject to the Enhydra Public License
 * Version 1.1 (the "License"); you may not use this file except in
 * compliance with the License. You may obtain a copy of the License on
 * the Enhydra web site ( http://www.enhydra.org/ ).
 * 
 * Software distributed under the License is distributed on an "AS IS"
 * basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See 
 * the License for the specific terms governing rights and limitations
 * under the License.
 * 
 * The Initial Developer of the Enhydra Application Server is Lutris
 * Technologies, Inc. The Enhydra Application Server and portions created
 * by Lutris Technologies, Inc. are Copyright Lutris Technologies, Inc.
 * All Rights Reserved.
 * 
 * Contributor(s):
 * 
 * $Id$
 */
package org.enhydra.kelp.jbuilder.properties;

// Kelp imports
import org.enhydra.kelp.common.node.OtterNode;
import org.enhydra.kelp.common.wizard.xmlc.XMLCOptionTab;

// Standard imports
import java.awt.*;
import java.awt.event.*;
import java.beans.*;
import java.io.File;
import javax.swing.*;
import javax.swing.border.*;
import javax.swing.event.*;

/**
 * Class declaration
 *
 *
 * @author Paul Mahar
 * @version $Revision$
 */
public class XMLCPackagePropertyPanel extends JPanel {
    private GridBagLayout   layoutMain  = null;
    private XMLCOptionTab   tab         = null;
    private OtterNode       node        = null;

    /**
     * Constructor declaration
     *
     *
     * @see
     */
    public XMLCPackagePropertyPanel() {
        try {
            jbInit();
            pmInit();
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    /**
     * Method declaration
     *
     *
     * @return
     *
     * @see
     */
    public OtterNode getNode() {
        return node;
    }

    /**
     * Method declaration
     *
     *
     * @param n
     *
     * @see
     */
    public void setNode(OtterNode n) {
        node = n;
    }

    /**
     * Method declaration
     *
     *
     * @exception Exception
     *
     * @see
     */
    private void pmInit() throws Exception {
        //
    }

    /**
     * Method declaration
     *
     *
     * @exception Exception
     *
     * @see
     */
    private void jbInit() throws Exception {
        layoutMain =
            (GridBagLayout) Beans.instantiate(getClass().getClassLoader(),
                                              GridBagLayout.class.getName());
        tab =
            (XMLCOptionTab) Beans.instantiate(getClass().getClassLoader(),
                                                XMLCOptionTab.class.getName());
        tab.setLayout(tab.getLayout());
        this.setLayout(layoutMain);
        this.add(tab,
                 new GridBagConstraints(0, 4, 1, 1, 0.1, 0.1,
                                        GridBagConstraints.CENTER,
                                        GridBagConstraints.HORIZONTAL,
                                        new Insets(3, 15, 5, 5), 0, 0));
    }

    /**
     * Method declaration
     *
     *
     * @see
     */
    public void readProperties() {
        boolean b = false;
        String  s = new String();

        tab.setNode(node);
        tab.init();
        tab.readProperties();
    }

    /**
     * Method declaration
     *
     *
     * @see
     */
    public void writeProperties() {
        tab.writeProperties();
    }

}
